diff --git a/channels/chan_sip.c b/channels/chan_sip.c
index 1307a93..d05f50d 100644
--- a/channels/chan_sip.c
+++ b/channels/chan_sip.c
@@ -22185,13 +22185,19 @@ static int build_reply_digest(struct sip_pvt *p, int method, char* digest, int d
 	const char *md5secret;
 	struct sip_auth *auth;	/* Realm authentication credential */
 	struct sip_auth_container *credentials;
+	char *domain_host;
 
-	if (!ast_strlen_zero(p->domain))
-		snprintf(uri, sizeof(uri), "%s:%s", p->socket.type == AST_TRANSPORT_TLS ? "sips" : "sip", p->domain);
-	else if (!ast_strlen_zero(p->uri))
+	if (!ast_strlen_zero(p->domain)) {
+		if((domain_host = strchr(p->domain, ':'))) {
+			snprintf(uri, sizeof(uri), "%s:%s", p->socket.type == AST_TRANSPORT_TLS ? "sips" : "sip", domain_host+1);
+		} else {
+			snprintf(uri, sizeof(uri), "%s:%s", p->socket.type == AST_TRANSPORT_TLS ? "sips" : "sip", p->domain);
+		}
+	} else if (!ast_strlen_zero(p->uri)) {
 		ast_copy_string(uri, p->uri, sizeof(uri));
-	else
+	} else {
 		snprintf(uri, sizeof(uri), "%s:%s@%s", p->socket.type == AST_TRANSPORT_TLS ? "sips" : "sip", p->username, ast_sockaddr_stringify_host_remote(&p->sa));
+	}
 
 	snprintf(cnonce, sizeof(cnonce), "%08lx", (unsigned long)ast_random());
 
